//+------------------------------------------------------------------+ 
//|   TRO_RANGE_HISTOGRAM                                            | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
 
#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2

#property  indicator_color1  Blue
#property  indicator_color2  Magenta

extern int myCorner= 1;
extern int x_offset= 1 ;//250
extern int y_offset= 10 ;//-160

extern bool Show_Histogram = true ; 
extern bool Show_PL = true ;

extern string myFont       = "Courier New" ;
extern int    myFontSize   = 12 ;

extern int       myLineWidth = 3;
extern int    AlertTime = 5 ;
extern color  AlertTimeColor = Magenta ;

extern int myPctHi = 66 ;
extern int myPctLo = 34 ;

extern color myTextColor   = DimGray ; 
extern color myPctHiColor  = Red ; 
extern color myPctMidColor = DimGray ; 
extern color myPctLoColor  = Blue ; 

extern int    myThreshold = 50 ;
extern color myThresholdColor = Magenta ;

double     H_Buffer[];
double     L_Buffer[];

double spread, Pct, point, range ;
double s1[];


string symbol, tChartPeriod,  tShortName, sSpread, sOpen, sPrice, sHigh, sLow, sPct ;  
int    digits2, digits, period, win, xInc, yInc, xPos, yPos,FILLAMT  ; 
 
string   tObjName01 , tObjName02 , tObjName03, tObjName04, tObjName05, tObjName06, tObjName07, tObjName08, tObjName09 ; 
string   tObjName10 ;
 
color colorPct, colorTime, colorPrice, colorHigh, colorLow, colorRange ; 
 

 
//+------------------------------------------------------------------+
int init()
  {


   period       = Period() ;  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;


   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   tShortName = symbol + tChartPeriod  ; 


if(Show_Histogram)
{
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,myLineWidth);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,myLineWidth);
   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,100);
   SetLevelValue(2,90);   
   SetLevelValue(3,80);
   SetLevelValue(4,70);
   SetLevelValue(5,60);
   SetLevelValue(6,50);
   SetLevelValue(7,40);  
   SetLevelValue(8,30); 
   SetLevelValue(9,20);    
   SetLevelValue(10,10);        
}
else
{
   SetIndexStyle(0,DRAW_NONE);  
   SetIndexStyle(1,DRAW_NONE); 
}

   SetIndexBuffer(0,H_Buffer);
   SetIndexBuffer(1,L_Buffer);
   
   IndicatorShortName("HL_Histogram");
   
   SetIndexLabel(0,"HiOp");
   SetIndexLabel(1,"OpLo");

 

   tObjName01 =   tShortName   + "hl01";
   tObjName02 =   tShortName   + "hl02";
   tObjName03 =   tShortName   + "hl03";
   tObjName04 =   tShortName   + "hl04";
   tObjName05 =   tShortName   + "hl05";
   tObjName06 =   tShortName   + "hl06";
   tObjName07 =   tShortName   + "hl07";
   tObjName08 =   tShortName   + "hl08";
   tObjName09 =   tShortName   + "hl09";
   tObjName10 =   tShortName   + "hl10";
      
   IndicatorShortName(tShortName);  
   
   FILLAMT = 18 ;
   deinit();
   
   return(0);
  }


//+------------------------------------------------------------------+  
int deinit()
  {
   ObjectsDeleteAll(win);
   TRO();
      
   return(0);
  }  
   
  
//+------------------------------------------------------------------+


int start()
  {
   
   win =    WindowFind(tShortName);
   ObjectsDeleteAll(win); 
           
   int limit;
   int counted_bars=IndicatorCounted();
 
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++)
   {
      L_Buffer[i] = 0 ;
      H_Buffer[i] = (High[i] - Low[i]) / point ;
      if( H_Buffer[i] > myThreshold ) { L_Buffer[i] = H_Buffer[i] ; }

   }

if(Show_PL) { DoShowPL () ; }
   
   return(0);
  }
//+------------------------------------------------------------------+

void DoShowPL ()
{

   yInc = myFontSize + 5 ;
   yPos = 0 ;
   
 
   if(Close[0] > Open[0]) { colorPrice = Lime ; } else if(Close[0] < Open[0]) { colorPrice = Red ; }
   else { colorPrice = Yellow ; }
   
    
   sPrice = symbol + " " + DoubleToStr(Close[0], digits ) ;
   
   ObjectCreate(tObjName06, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName06,fFill(sPrice, FILLAMT) , myFontSize, myFont, colorPrice );  
   ObjectSet(tObjName06, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName06, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName06, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //     
//+--------   

   RefreshRates();
   
   spread  = MarketInfo(symbol,MODE_SPREAD) * 0.1 ; 
   sSpread = "Spread " + DoubleToStr(spread,1 ) ;
   
   yPos = yPos + yInc ;
   
   ObjectCreate(tObjName02, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName02, fFill(sSpread, FILLAMT) , myFontSize, myFont, myTextColor );  
   ObjectSet(tObjName02, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName02, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName02, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //  
//+--------
 
   
   
//+--------
 
   string sHiOp = "Hi-Op " + DoubleToStr( (High[0] - Open[0]) / point ,0 ) ;

   yPos = yPos + yInc ;
      
   ObjectCreate(tObjName03, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName03, fFill(sHiOp, FILLAMT) , myFontSize, myFont, myTextColor );  
   ObjectSet(tObjName03, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //  
//+--------


   string sLoOp = "Op-Lo " + DoubleToStr( (Open[0] - Low[0]) / point,0 ) ;

   yPos = yPos + yInc ;
   
   ObjectCreate(tObjName04, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName04,  fFill(sLoOp, FILLAMT)  , myFontSize, myFont, myTextColor );  
   ObjectSet(tObjName04, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName04, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName04, OBJPROP_YDISTANCE, (yPos+myFontSize)+y_offset); // 
//+--------
   
//   double Current  = (Close[0]  - Open[0]) / point  ;
//   string sCurrent = "Cl-Op " + DoubleToStr( Current ,0 ) ;

   double Range  = (High[0]  - Low[0]) / point  ;
   string sRange = "Range " + DoubleToStr( Range ,0 ) ;
   if(Range > myThreshold) { colorRange = Magenta ; } else { colorRange = Blue ; }

   yPos = yPos + yInc ;
   
   ObjectCreate(tObjName01, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName01,  fFill(sRange, FILLAMT) , myFontSize, myFont, colorRange );  
   ObjectSet(tObjName01, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName01, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName01, OBJPROP_YDISTANCE, (yPos+myFontSize)+y_offset); // 


   

//+--------

   yPos = yPos + yInc ;  
  
  
  
   if( Range != 0) { Pct = 100 * ( Close[0]  - Low[0] ) / (High[0]  - Low[0])  ; } else {Pct = 0 ;} 

   sPct = "Pct " + DoubleToStr(Pct, 0 ) + " %";

   if(Pct > myPctHi ) { colorPct = myPctHiColor ; } else  
   if(Pct < myPctLo ) { colorPct = myPctLoColor ; } else { colorPct = myPctMidColor ; }
        
   
   ObjectCreate(tObjName10, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName10, fFill(sPct, FILLAMT) , myFontSize, myFont, colorPct );  
   ObjectSet(tObjName10, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName10, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName10, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //         
      

//+--------

   yPos = yPos + yInc ;   
   
   sOpen = "Open " + DoubleToStr(Open[0], digits ) ;
   
   ObjectCreate(tObjName05, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName05,  fFill(sOpen, FILLAMT) , myFontSize, myFont, myTextColor );  
   ObjectSet(tObjName05, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName05, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName05, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //     

//+--------

   yPos = yPos + yInc ;  

   if(Close[0] == High[0]) { colorHigh = Lime ; } else  { colorHigh = Green ; }
       
   sHigh = "High " + DoubleToStr(High[0], digits ) ;
   
   ObjectCreate(tObjName07, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName07,  fFill(sHigh, FILLAMT) , myFontSize, myFont, colorHigh );  
   ObjectSet(tObjName07, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName07, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName07, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //   

//+--------

   yPos = yPos + yInc ;  

   if(Close[0] == Low[0]) { colorLow = Red ; } else  { colorLow = FireBrick ; }
       
   sLow = "Low " + DoubleToStr(Low[0], digits ) ;
   
   ObjectCreate(tObjName08, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName08, fFill(sLow, FILLAMT) , myFontSize, myFont, colorLow );  
   ObjectSet(tObjName08, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName08, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName08, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //      
   
   
   
//+--------   

   yPos = yPos + yInc ;  
    
	double bi;
   int bm,bs;
   
   bm=Time[0]+Period()*60-CurTime();
   bi=bm/60.0;
   bs=bm%60;
   bm=(bm-bm%60)/60;
   
   if(bm < AlertTime ) { colorTime = AlertTimeColor ; } else { colorTime = myTextColor ; }
   
   string sTime = tChartPeriod + " End: " + bm + "m " + bs + "s" ;

   ObjectCreate(tObjName09, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName09,  fFill(sTime, FILLAMT) , myFontSize, myFont, colorTime );  
   ObjectSet(tObjName09, OBJPROP_CORNER, myCorner);
   ObjectSet(tObjName09, OBJPROP_XDISTANCE, 0+x_offset); // 
   ObjectSet(tObjName09, OBJPROP_YDISTANCE, yPos+myFontSize+y_offset); //      
//+--------   	 
 
}        
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}

//+------------------------------------------------------------------+

void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
  